#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2003-2008 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################

use File::Copy;
use File::Spec;

################################################################################
# use the CMS to get the file version
# Arguments:
#   input filePathName
# Return value:
#   output file version or ??
################################################################################
sub getFileVersion #($)
{
	my $file=shift;
	my $ver="??";
	my $cmd="";
	$_=$FILEVERCMS;
	$_=$CMSTOOL if(/default/);
	  SWITCH: {
	      /ClearCase$/ && do {
			$cmd=$ENV{ATRIAHOME}.PATH_SEPARATOR.'bin'.PATH_SEPARATOR if(defined($ENV{ATRIAHOME}));
			$cmd=~s,\\,\\\\,g;
			my $txt=`${cmd}cleartool ls $file`;
			if($txt=~m/\sfrom\s+([^\s]*)\s/)
			{
				$ver=$1." (CHECKEDOUT)";
			}
			else {
				$txt=~m/\@\@([^\s]*)\s/;
	      			$ver=$1;
			}
	      			last SWITCH; };
	      /^CVS$/ && do {
			my $cvsRoot;
			unless(defined($ENV{CVSROOT})){
				my ($d,$b,$e)=SplitFileName($file);
				if(open(RR,"${d}CVS/Root")){
					chomp($cvsRoot=<RR>);
					$cvsRoot="-d\"$cvsRoot\"";
					close RR;
				}
			}
			my $cmd="cvs $cvsRoot status $file";
			print "$cmd\n" if($ENV{ATTOLSTUDIO_VERBOSE});
			my $txt=`$cmd`;
	      		$txt=~m/Working revision:\s*(.*)\n/;
			$ver=$1;
	      			last SWITCH; };
	      /^custom$/ && do {
		# add your custom code here to get the version of the file $file
	      	# the result must be in the $ver
		print "Warning: the file ",__FILE__," line ",__LINE__ -2," has not been customized yet.\nContact the person who installed Test RealTime.\n"; 
		$ver=GetDateOf(GetModificationTime($file));
		# end of your custom code
	      			last SWITCH; };


	  } 

	return $ver;
}

#### main test ####
#$FILEVERCMS="custom"; my $v=getFileVersion($ARGV[0]); print "$ARGV[0] version is $v\n";

1;
