#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2005-2007 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################

##########################################################################
#                                                                        # #
# Rational Test RealTime                                                 #   #
#                                                                        #######
#                 -*-  code ckecker Analysis  -*-                              #
#                                                                              #
#                                                                              #
################################################################################
#$Id: codeChecker.pl,v 1.33.4.5 2010/11/05 15:09:18 rfrance Exp $
################################################################################


sub codeChecker_cc #($)
{
	my $src=shift;
	print &PerlTranslate("codeChecker.pl", "%1: Code checking...\n", "%1 is the name of the file to be analized", $src);
	my ($d,$n,$e)=SplitFileName($src);
	my $deffile="atus_c.def";
	my $cppOpt="";
	if(LanguageOf($e) eq "CPP") {
		$deffile="atl.hpp";
		$cppOpt="-CPP";
		$MISRA_CONF=~s/\\/\//g;
		$MISRA_CONF=$ENV{'TESTRTDIR'}.$MISRA_DEFAULT_CPP_CONF if($MISRA_CONF=~m/$MISRA_DEFAULT_C_CONF$/);
	}
	my $opt;
	my $command="crccc \"$src\" \"$INTDIR/$n.xob\" $deffile atl.opp $cppOpt -RULE=\"$MISRA_CONF\"";
	$command.=" -silent=$CHECK_SILENT" if($CHECK_SILENT >= 0);
	$command.=" -checksysinclude" if($CHECK_SYS_INC);
	if(($FILEVERCMS) && ($FILEVERCMS ne '0'))
	{
		print &PerlTranslate("codeChecker.pl", "Check file's version\n", "");
		my $v=getFileVersion($src);
		$command.=" -fileversion=\"$v\"";
	}
	my @nocheckincl=@NOCHECK_DIR_INC;
	my @sysincl=split(/,/,$Ini{STD_INCLUDE});
	my @include_dir;
	my $found;
	foreach my $incl (@COMPLETE_INCLUDE_DIR_LIST){
		foreach (@sysincl){
			if($incl=~ m/^\Q$_\E.*$/){
				push(@nocheckincl,$incl);
				$found=1;
				LAST;
			} else {
				if(s/^\w\://){
					if($incl=~ m/^\Q$_\E.*$/){
						push(@nocheckincl,$incl);
						$found=1;
						LAST;
					}
				}
			}
		}
		push(@include_dir,$incl) unless($found);
		$found=0;
	}
	$opt=' -std_incl="'.join(',',@nocheckincl).'"' if(@nocheckincl);
	$opt.=' -incl="'.join(',',@include_dir).'"' if(@include_dir);
	
	$opt=~ s,([\\\/])",$1.",g;
	$command.=$opt;
	$command.=' -preinclude="'.join('","',@INCLUDED_FILES).'"' if(@INCLUDED_FILES);
	$command.=" -define=\"".join("\",\"",@GENERATION_CONDITION)."\"" if(@GENERATION_CONDITION);
	my $ret = SystemP($command);
	return "" if($ret);
	open ( LOG, ">>$LOGFILENAME" ) or die &PerlTranslate("codeChecker.pl", "Cannot open log file: %1\n", "%1 is the reason given by the Operating System", $!);
	print  LOG "XOB $INTDIR/$n.xob\n";
	close( LOG );
	return "$INTDIR/$n.xob";
}

sub codeChecker_link
{
        print &PerlTranslate("codeChecker.pl", "%1: Code checking report...\n", "%1 is the name of the file to be analized", $NAME);
	if($TDP_LANGUAGE eq "CPP") {
		$MISRA_CONF=~s/\\/\//g;
		$MISRA_CONF=$ENV{'TESTRTDIR'}.$MISRA_DEFAULT_CPP_CONF if($MISRA_CONF=~m/$MISRA_DEFAULT_C_CONF$/);
	}        
        my $check_script;
	if($NAME_CHECK_SCRIPT){ #customer checking the naming rule
		$check_script=$NAME_CHECK_SCRIPT;
		$check_script.=".pl" unless($NAME_CHECK_SCRIPT =~ /\.pl$/);
		unless($check_script =~ m/[\\\/]/) {# if there is no path
			unless(-f $check_script){   # and the file does not exist
				$check_script=$SCRIPTDIR.$check_script; # look for it into the scripts dir
			}
		}
		if(-f $check_script){
			my $command="crcld -xref=\"$OUTDIR/$NAME.pl\" \"".join("\" \"",@XOB)."\" -RULE=\"$MISRA_CONF\"";
			$command.= " -TEST" if($ATOMODE || $ATUMODE || $ATVMODE || $ATSMODE);
			my $ret = SystemP($command);

			require $check_script;
			my $nrxob=namingRuleCheck("$OUTDIR/$NAME.pl");
			push(@XOB,$nrxob) if($nrxob);
		}else{
			print &PerlTranslate("codeChecker.pl", "%1: Name checking script not found\n", "%1 is the name of the script", $check_script);
		}
	}
	my $command="crcld -crc=\"$OUTDIR/$NAME.crc\" \"".join("\" \"",@XOB)."\" -RULE=\"$MISRA_CONF\"";
	$command.= " -TEST" if($ATOMODE || $ATUMODE ||  $ATVMODE || $ATSMODE);
	my $ret = SystemP($command);
	if($ret) {
	     print &PerlTranslate("codeChecker.pl", "Code checking report generation failed.($ret)\n");
	     return "";
	}
	open ( LOG, ">>$LOGFILENAME" ) or die &PerlTranslate("codeChecker.pl", "Cannot open log file: %1\n", "%1 is the reason given by the Operating System", $!);
	print  LOG "CRC $OUTDIR/$NAME.crc\n";
	close( LOG );
	return "$OUTDIR/$NAME.crc";
}

1;
