/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
package com.ibm.rqm.adapter.commandline;

import com.ibm.rqm.adapter.library.data.CustomProperty;
import com.ibm.rqm.adapter.library.data.ILogEvent;
import com.ibm.rqm.adapter.library.data.AbstractLogResult;
import com.ibm.rqm.adapter.library.data.ResultStateEnum;

/**
 * An entity which holds the details about the execution collected and built up
 * during execution to be later uploaded to the QM server
 * 
 * @author psinha
 * 
 */
public class CommandLineLogResult extends AbstractLogResult {
	
	/**
	 * @param buildId the buildId to set
	 */
	public void setBuildId(String buildId) {
		this.buildId = buildId;
	}

	/**
	 * @param customProperties the customProperties to set
	 */
	public void setCustomProperties(CustomProperty[] customProperties) {
		this.customProperties = customProperties;
	}

	/**
	 * @param defectLinks the defectLinks to set
	 */
	public void setDefectLinks(String[] defectLinks) {
		this.defectLinks = defectLinks;
	}

	/**
	 * @param link the eWILink to set
	 */
	public void setEWILink(String link) {
		eWILink = link;
	}

	/**
	 * @param endTime the endTime to set
	 */
	public void setEndTime(long endTime) {
		this.endTime = endTime;
	}

	/**
	 * @param startTime the startTime to set
	 */
	public void setStartTime(long startTime) {
		this.startTime = startTime;
	}

	/**
	 * @param logEvents the logEvents to set
	 */
	public void setLogEvents(ILogEvent[] logEvents) {
		this.logEvents = logEvents;
	}

	/**
	 * @param machine the machine to set
	 */
	public void setMachine(String machine) {
		this.machine = machine;
	}

	/**
	 * @param pointsAttempted the pointsAttempted to set
	 */
	public void setPointsAttempted(int pointsAttempted) {
		this.pointsAttempted = pointsAttempted;
	}

	/**
	 * @param pointsBlocked the pointsBlocked to set
	 */
	public void setPointsBlocked(int pointsBlocked) {
		this.pointsBlocked = pointsBlocked;
	}

	/**
	 * @param pointsFailed the pointsFailed to set
	 */
	public void setPointsFailed(int pointsFailed) {
		this.pointsFailed = pointsFailed;
	}

	/**
	 * @param pointsInconclusive the pointsInconclusive to set
	 */
	public void setPointsInconclusive(int pointsInconclusive) {
		this.pointsInconclusive = pointsInconclusive;
	}

	/**
	 * @param pointsPassed the pointsPassed to set
	 */
	public void setPointsPassed(int pointsPassed) {
		this.pointsPassed = pointsPassed;
	}

	/**
	 * @param status the status to set
	 */
	public void setStatus(ResultStateEnum status) {
		this.status = status;
	}

	/**
	 * @param testCaseLink the testCaseLink to set
	 */
	public void setTestCaseLink(String testCaseLink) {
		this.testCaseLink = testCaseLink;
	}

	/**
	 * @param testScriptLink the testScriptLink to set
	 */
	public void setTestScriptLink(String testScriptLink) {
		this.testScriptLink = testScriptLink;
	}
}
