/*
  Licensed Materials - Property of IBM
  Restricted Material of IBM
  IBM Rational Test RealTime
  (c) Copyright IBM Corp. 2003-2004 All Rights Reserved.

  US Governement Users Restricted Rights - Use, duplication or
  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*/
/* AtsMain.c for VxWorks V1.0 richard.france */
/* This AtsMain.c[pp] is a thread launcher for system testing
        It should be located in the targets/<target>/lib directory
        It is used when Virtual testers are generated as threads and this file exist in the TDP
*/

#include <stdio.h>
#include <stdlib.h>

#include <vxworks.h>
/* #include "taskLib.h"

#include "taskVarLib.h" */

#ifndef ATS_PRIORITY
#define ATS_PRIORITY 100
#endif
#ifndef ATS_OPTIONS
#define ATS_OPTIONS 0
#endif
#ifndef ATS_STACKSIZE
#define ATS_STACKSIZE 16000
#endif

/*! Expected argument type in start routine of thread mode name of rio file
 * to generate list of filters set. */
typedef struct {
  char *atl_riofilename;
  char *atl_filters;
  char *atl_instance;
  int   atl_occid;
} ATL_T_ARG, *ATL_PT_ARG;
#define ATL_T_THREAD_RETURN void

#ifdef ATTOLSTUDIO_VERBOSE
#define trace printf
#define traceEnd
#endif
#ifndef trace
#define trace /##/ /* /##* for begin C comment */
#define traceEnd  /* *##/ for end C comment */
#endif

#ifdef __cplusplus
#define EXTERN extern "C"
#else
#define EXTERN extern
#endif
EXTERN int atl_strncmp(char*, char*, int);

#define ATLStart() ATL_Start
#define CONCAT(a,b) a##b
#define THREADSTABLELEN CONCAT(ATLStart(),_TableLen)
#define THREADSTABLE CONCAT(ATLStart(),_Table)

extern int THREADSTABLELEN;
extern char * THREADSTABLE[];
extern ATL_T_THREAD_RETURN  ATL_Start(ATL_PT_ARG arg);

int Tmain_instance(int vt,int occid) /* VxWorks thread entry point */
{
char *c,*p;
ATL_T_ARG arg;
		   c=THREADSTABLE[vt];
		   p=malloc(strlen(c)+4+1+1);
		   arg.atl_instance=c;
		   arg.atl_riofilename=p;
		trace("Instance %s starting\n",c);
		   while(*c){*p++=*c++;}
		   if(occid){*p++=('@'+occid);}
		   c=".rio";
		   while(*c){*p++=*c++;}
		   *p=0;
		   arg.atl_filters="";
		   arg.atl_occid=occid;
	ATL_Start(&arg);
return (0);
}

int Tmain()
{
 int threadNo=0;
 int NB_THREAD=0;
 int i,ret;

	NB_THREAD=THREADSTABLELEN-1;
	threadNo=0;
	while(threadNo<NB_THREAD)
	{
		i= taskSpawn ("ATS_thread_start","vt",
					PRIORITY, OPTIONS, STACKSIZE,
					Tmain_instance, (int)(threadNo),
					0, 0, 0, 0, 0, 0, 0, 0, 0);
	trace("Instance %s\n",THREADSTABLE[threadNo]);
	threadNo++;
	}
	/* last VT (INSTANCE) start it directly */
    ATS_thread_start(threadNo);

    return 0;
}
