

/*
 *  Licensed Materials - Property of IBM
 *  Restricted Material of IBM
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


/*******************************************************************************
* $Id: rtvalues.h,v 1.15.4.11 2010/05/10 14:27:51 rfrance Exp $
* $Descr: Customization macros values definition $
*******************************************************************************/
/* Multiple inclusions guard: */
#ifndef RTVALUES_H_INCLUDED
#define RTVALUES_H_INCLUDED

#define RTRT_NONE 0
#define RTRT_STD 1
#define RTRT_SOLARIS 2
#define RTRT_USR 3
#define RTRT_HASH 4
#define RTRT_TINY_THREADID 5
#define RTRT_HOOK 6
#define RTRT_AUTO 7
#define RTRT_SOCKET 8

#ifndef ATL_YES
#define ATL_YES 1
#define ATL_NO  0
#endif

#ifndef ATL_MULTI_THREADS
#define ATL_MULTI_THREADS 0
#endif

#ifdef ATL_CPLUSPLUS_INSTRUMENTOR
#define ATL_STACKLINK _atl_stack_object._atl_stack_link
#else
#define ATL_STACKLINK _atl_stack_link
#endif

#define RTRT_TDP_INIT_NEEDS 1
#define RTRT_IO_NEEDS 1
#define RTRT_ERROR_NEEDS 1
#define RTRT_CLOCK_NEEDS 1
#define RTRT_EXIT_NEEDS 1

#if USE_ATU || USE_ATO || USE_ATS || USE_ATP || USE_ATV
#define RTRT_MEMCPY_NEEDS 1
#endif

#if USE_ATU || USE_ATC || USE_ATP || USE_ATQ || USE_ATV
#define RTRT_GET_DATE_NEEDS 1
#endif

#if USE_ATU || USE_ATS || USE_ATV
#if USE_ATS
#define RTRT_SLEEP_NEEDS
#define RTRT_ATSMAIN_NEEDS
#define RTRT_RDV_NEEDS
#define RTRT_GETHOSTNAME_NEEDS
#endif
#else
#define RTRT_ATEXIT_NEEDS 1
#ifdef RTRT_TDP_COMPILATION
#if ATL_MULTI_PROCESS
#define RTRT_GETPID_NEEDS 1
#endif /* ATL_MULTI_PROCESS */
#endif
#endif

#if USE_ATC || USE_ATT || USE_ATP || USE_ATQ || USE_ATS
#define RTRT_GETENV_NEEDS 1
#endif

#if USE_ATC || USE_ATT || USE_ATP || USE_ATS
#define RTRT_SIGNAL_NEEDS 1
#endif

#ifdef RTRT_TDP_COMPILATION
#if USE_ATP || USE_ATS || USE_ATK || (ATL_DYN_TABLE && (USE_ATC || USE_ATQ))
#define RTRT_HEAP_NEEDS 1
#endif
#endif

#if USE_ATP
#define RTRT_LOWLEVEL_MEMLIB_NEEDS
#define RTRT_MEMLIB_EXTENSION_NEEDS
#ifdef ATP_REPORTS_FIU
#if ATP_REPORTS_FIU
#define RTRT_ISOPENMET_NEEDS
#endif
#endif
#endif

#if USE_ATQ
#define RTRT_THREAD_CLOCK_NEEDS
#endif

#if USE_ATK || USE_ATT || USE_ATP || USE_ATQ
#define RTRT_LONGJMP_NEEDS 1
#define RTRT_THREADS_NEEDS 1
#define RTRT_THREADIDX_NEEDS 1
#endif

#endif
